<?php
/************************************************************************
 * Mailer v0.2.1-FINAL                                Start: 07/27/2011 *
 * ===================                          Last change: 07/27/2011 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : forced_filter.php                                *
 * -------------------------------------------------------------------- *
 * Short description : Filters for ext-forced                           *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Filter fuer ext-forced                           *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2009 by Roland Haeder                           *
 * Copyright (c) 2009 - 2012 by Mailer Developer Team                   *
 * For more information visit: http://mxchange.org                      *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if (!defined('__SECURITY')) {
	die();
} // END - if

// Filter to add default forced-ad types
function FILTER_FORCED_AD_TYPE_DEFAULTS ($data) {
	// Forced-Banner
	array_push(
		$data,
		array(
			// Forced-Banner
			'type' => 'BANNER',
		), array(
		 	// Forced-Textlinks
			'type' => 'TEXTLINK',
		), array(
			// Forced-PopUp
			'type' => 'POPUP',
		)
	);

	// Return data
	return $data;
}

// Filter for collecting data for the member table
function FILTER_FORCED_POPUP_TABLE_DATA ($filterData) {
	//* DEBUG: */ logDebugMessage(__FUNCTION__, __LINE__, 'Called!');
	// Is this the right filter?
	if ($filterData['earning_provider'] == 'FORCED_POPUP') {
		// Set group
		$filterData['earning_group'] = 'POPUP';

		// Get max/min/count of all popups
		// @TODO This part is unfinished
		//die(__FUNCTION__.':OK!');
	} // END - if

	// Return filter data array
	//* DEBUG: */ logDebugMessage(__FUNCTION__, __LINE__, 'Done!');
	return $filterData;
}

// Filter for changing URL status
function FILTER_FORCED_CHANGE_CAMPAIGN_STATUS ($filterData) {
	/*
	// Do some dirty fixing here:
	if (($filterData['data']['forced_campaign_status'] == 'STOPPED') && ($filterData['new_status'] == 'pending')) {
		// Fix for template change
		$filterData['new_status'] = 'continued';
	} // END - if
	*/

	// Send admin notification
	doForcedNotifyAdmin('campaign_' . strtolower($filterData['data']['forced_campaign_status']) . '_' . $filterData['new_status'], $filterData['data']);

	// Send user notification
	doForcedNotifyMember('campaign_' . strtolower($filterData['data']['forced_campaign_status']) . '_' . $filterData['new_status'], $filterData['data']);

	// Return filter data
	//* DEBUG: */ logDebugMessage(__FUNCTION__, __LINE__, 'Done!');
	return $filterData;
}

// Filter for validating status
function FILTER_FORCED_CHANGE_CAMPAIGN_VALIDATE_DATA ($filterData) {
	// Is the new status set?
	//* DEBUG: */ logDebugMessage(__FUNCTION__, __LINE__, 'Called!');
	if ((!is_string($filterData['new_status'])) || (empty($filterData['new_status']))) {
		// Abort here, not fine
		//* DEBUG: */ logDebugMessage(__FUNCTION__, __LINE__, 'newStatus[' . gettype($filterData['new_status']) . ']=' . $filterData['new_status'] . ' - EXIT!');
		$filterData['abort'] = FALSE;
	} elseif ($filterData['data']['forced_campaign_status'] != $filterData['prev_status']) {
		// Status is not like prevStatus
		//* DEBUG: */ logDebugMessage(__FUNCTION__, __LINE__, $filterData['data']['forced_campaign_status'] . '!=' . $filterData['prev_status'] . ' - EXIT!');
		$filterData['abort'] = FALSE;
	} // END - if

	// Return filter data
	//* DEBUG: */ logDebugMessage(__FUNCTION__, __LINE__, 'Done!');
	return $filterData;
}

// Filter for handling click on forced ad
function FILTER_HANDLE_FORCED_AD_CLICK ($filterData) {
	// Are all required parameters set?
	//* DEBUG: */ logDebugMessage(__FUNCTION__, __LINE__, 'Called!');
	die(__FUNCTION__.': CALLED!');

	// Return filter data
	//* DEBUG: */ logDebugMessage(__FUNCTION__, __LINE__, 'Done!');
	return $filterData;
}

// Filter for handling viewing forced banner
function FILTER_HANDLE_FORCED_AD_VIEW ($filterData) {
	// Are all required parameters set?
	//* DEBUG: */ logDebugMessage(__FUNCTION__, __LINE__, 'Called!');
	die(__FUNCTION__.': CALLED!');

	// Return filter data
	//* DEBUG: */ logDebugMessage(__FUNCTION__, __LINE__, 'Done!');
	return $filterData;
}

// [EOF]
?>
